<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<link rel="import" href="../../bower_components/iron-localstorage/iron-localstorage.html">

<link rel="import" href="dez-login.html">
<link rel="import" href="dez-profile-menu.html">

<dom-module id="dez-auth">
  <template>
    <style>
    </style>

    <dez-login id="login" auth-server="[[authServer]]" visible="[[_loginVisible]]"></dez-login>
    <dez-profile-menu id="profile" auth-server="[[authServer]]" visible="[[_logoutVisible]]"></dez-profile-menu>

    <iron-localstorage id="localStorage" name="user-storage" value="{{_storedUser}}"></iron-localstorage>

  </template>

  <script>

  class DezAuth extends Polymer.Element {

    static get is() { return 'dez-auth'; }

    static get properties() {
      return {
        jwt: {
          type : String,
          value : "",
          readOnly : true,
          notify : true
        },
        authServer : String,
        visible : {
          type : Boolean,
          value : false,
          observer : '_displayLogin'
        }
      }
    }

    constructor () {
      super()
      this._loginVisible = false
      this._logoutVisible = false
    }

    _displayLogin () {
      if (this._storedUser) {
        this._loginVisible = this.visible && !this._storedUser.loggedin
        this._logoutVisible = this.visible && this._storedUser.loggedin
      } else {
        this._loginVisible = this.visible && true
        this._logoutVisible = this.visible && false
      }
    }

    get isLoggedIn() {
      return !!this._storedUser;
    }

    openLoginDialog() {
      this.$.login.openLoginDialog()
    }

    ready () {
      super.ready()
      this.$.localStorage.addEventListener('iron-localstorage-load', () => {
        if (this._storedUser) {
          let payload = JSON.parse(window.atob(this._storedUser.access_token.split('.')[1]))
          if (payload.exp < Date.now()/1000) {
            this._storedUser = null
          } else {
            this.$.profile.user = this._storedUser
            this._setJwt(this._storedUser.access_token)
          }
          this._displayLogin()
        }
      })
      this.$.login.addEventListener('user-logged-in', e => {
        this._storedUser = e.detail
        this._displayLogin()
        this._setJwt(this._storedUser.access_token);
        this.$.profile.user = this._storedUser
      })
      this.$.profile.addEventListener('user-logged-out', () => {
        this._storedUser = null
        this._displayLogin()
        this._setJwt("");
      })
      this.$.profile.addEventListener('user-changed-password', e => {
        this._storedUser = e.detail
        this._setJwt(this._storedUser.access_token);
      })

    }

  }

  window.customElements.define(DezAuth.is, DezAuth);

  </script>
</dom-module>
